---
title: "Vecteurs de dates"
weight: 14
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<div id="plusieurs-formats" class="section level3">
<h3>Plusieurs formats</h3>
<pre class="r"><code>dates &lt;- c(&quot;02/27/92&quot;, &quot;02/27/92&quot;, &quot;01/14/92&quot;, &quot;02/28/92&quot;, &quot;02/01/92&quot;)
as.Date(dates, &quot;%m/%d/%y&quot;)</code></pre>
<pre><code>## [1] &quot;1992-02-27&quot; &quot;1992-02-27&quot; &quot;1992-01-14&quot; &quot;1992-02-28&quot; &quot;1992-02-01&quot;</code></pre>
<pre class="r"><code>as.Date(dates, &quot;%m/%d/%y&quot;)|&gt;class()</code></pre>
<pre><code>## [1] &quot;Date&quot;</code></pre>
<pre class="r"><code>Sys.time()</code></pre>
<pre><code>## [1] &quot;2022-12-08 04:52:41 CET&quot;</code></pre>
<pre class="r"><code>Sys.time()|&gt;class()</code></pre>
<pre><code>## [1] &quot;POSIXct&quot; &quot;POSIXt&quot;</code></pre>
<ul>
<li>Dans ce cours, on se limitera aux Dates.</li>
</ul>
</div>
<div id="création" class="section level3">
<h3>Création</h3>
<ul>
<li>Transformer une chaîne de caractères en Date</li>
</ul>
<pre class="r"><code>x&lt;-as.Date(&quot;02/27/92&quot;, &quot;%m/%d/%y&quot;)
lubridate::mdy(&quot;02/27/92&quot;)</code></pre>
<pre><code>## [1] &quot;1992-02-27&quot;</code></pre>
<pre class="r"><code>lubridate::yq(&quot;92 T3&quot;)</code></pre>
<pre><code>## [1] &quot;1992-07-01&quot;</code></pre>
<ul>
<li>ex nihilo</li>
</ul>
<pre class="r"><code>x&lt;-lubridate::mdy(&quot;02/27/92&quot;,&quot;04/27/92&quot;)
seq.Date(from=x[1],to=x[2], by=&quot;day&quot;)</code></pre>
<pre><code>##  [1] &quot;1992-02-27&quot; &quot;1992-02-28&quot; &quot;1992-02-29&quot; &quot;1992-03-01&quot; &quot;1992-03-02&quot;
##  [6] &quot;1992-03-03&quot; &quot;1992-03-04&quot; &quot;1992-03-05&quot; &quot;1992-03-06&quot; &quot;1992-03-07&quot;
## [11] &quot;1992-03-08&quot; &quot;1992-03-09&quot; &quot;1992-03-10&quot; &quot;1992-03-11&quot; &quot;1992-03-12&quot;
## [16] &quot;1992-03-13&quot; &quot;1992-03-14&quot; &quot;1992-03-15&quot; &quot;1992-03-16&quot; &quot;1992-03-17&quot;
## [21] &quot;1992-03-18&quot; &quot;1992-03-19&quot; &quot;1992-03-20&quot; &quot;1992-03-21&quot; &quot;1992-03-22&quot;
## [26] &quot;1992-03-23&quot; &quot;1992-03-24&quot; &quot;1992-03-25&quot; &quot;1992-03-26&quot; &quot;1992-03-27&quot;
## [31] &quot;1992-03-28&quot; &quot;1992-03-29&quot; &quot;1992-03-30&quot; &quot;1992-03-31&quot; &quot;1992-04-01&quot;
## [36] &quot;1992-04-02&quot; &quot;1992-04-03&quot; &quot;1992-04-04&quot; &quot;1992-04-05&quot; &quot;1992-04-06&quot;
## [41] &quot;1992-04-07&quot; &quot;1992-04-08&quot; &quot;1992-04-09&quot; &quot;1992-04-10&quot; &quot;1992-04-11&quot;
## [46] &quot;1992-04-12&quot; &quot;1992-04-13&quot; &quot;1992-04-14&quot; &quot;1992-04-15&quot; &quot;1992-04-16&quot;
## [51] &quot;1992-04-17&quot; &quot;1992-04-18&quot; &quot;1992-04-19&quot; &quot;1992-04-20&quot; &quot;1992-04-21&quot;
## [56] &quot;1992-04-22&quot; &quot;1992-04-23&quot; &quot;1992-04-24&quot; &quot;1992-04-25&quot; &quot;1992-04-26&quot;
## [61] &quot;1992-04-27&quot;</code></pre>
</div>
<div id="récupérer-les-années-les-mois" class="section level3">
<h3>Récupérer les années, les mois …</h3>
<pre class="r"><code>x&lt;-as.Date(&quot;02/27/92&quot;, &quot;%m/%d/%y&quot;)
lubridate::year(x)</code></pre>
<pre><code>## [1] 1992</code></pre>
<pre class="r"><code>lubridate::year(x)|&gt;class()</code></pre>
<pre><code>## [1] &quot;numeric&quot;</code></pre>
<pre class="r"><code>lubridate::quarter(x)</code></pre>
<pre><code>## [1] 1</code></pre>
<pre class="r"><code>lubridate::month(x)</code></pre>
<pre><code>## [1] 2</code></pre>
</div>
<div id="filtres-sur-les-dates" class="section level3">
<h3>Filtres sur les dates</h3>
<pre class="r"><code>x&lt;-lubridate::mdy(&quot;02/27/92&quot;,&quot;03/27/92&quot;,&quot;04/27/92&quot;)
x[1]&lt;x[2]&amp;x[2]&lt;x[3]</code></pre>
<pre><code>## [1] TRUE</code></pre>
<pre class="r"><code>x[2]-x[1]</code></pre>
<pre><code>## Time difference of 29 days</code></pre>
<pre class="r"><code>x[3]-x[2]</code></pre>
<pre><code>## Time difference of 31 days</code></pre>
<pre class="r"><code>lubridate::as.difftime(x[3]-x[2],units = &quot;days&quot;)</code></pre>
<pre><code>## Time difference of 31 days</code></pre>
<pre><code>- Calculer le nombre de jours jusqu&#39;au samedi 28 octobre 2023</code></pre>
<hr />
<details>
<summary>
Solution
</summary>
<pre class="r"><code>lubridate::as.difftime(Sys.Date()-lubridate::dmy(&quot;28/10/23&quot;),units = &quot;days&quot;)</code></pre>
<pre><code>## Time difference of -324 days</code></pre>
</details>
<hr />
</div>
